**Please strictly follow the guidelines below**

## Codebase Analysis

### Task Summary

{summary}

### Solution Concept

{initialConcept}

## Technical Review Points

Pay attention to opportunities for code reuse, avoid reimplementing existing functionality, and mitigate technical debt risks.

### 1. Codebase Analysis

- Look for reusable components and similar implementations
- Determine the appropriate location for the new functionality
- Evaluate integration methods with existing modules

### 2. Technical Strategy Evaluation

- Consider modularity and scalability in the design
- Assess the future compatibility of the proposal
- Plan testing strategies and coverage

### 3. Risk and Quality Analysis

- Identify technical debt and performance bottlenecks
- Evaluate security and data integrity
- Check error handling mechanisms

### 4. Implementation Recommendations

- Follow project architectural style
- Recommend implementation methods and technology choices
- Propose clear development steps

{previousAnalysis}

## Next Actions

After completing the analysis, use the "reflect_task" tool to submit the final analysis, including:

1. **Original Task Summary** - Keep consistent with the first stage
2. **Complete Analysis Results** - Technical details, interface dependencies, implementation strategy, acceptance criteria

Your analysis will determine the quality of the solution. Please comprehensively consider various technical factors and business constraints.
**Using tools is strictly required.**
