**請嚴格遵守以下指導**

## 方案評估

### 任務摘要

{summary}

### 分析結果

{analysis}

## 評估要點

### 1. 技術完整性

- 檢查方案技術缺陷和邏輯漏洞
- 驗證邊緣情況和異常處理
- 確認數據流和控制流完整性
- 評估技術選型合理性

### 2. 效能與可擴展性

- 分析資源使用效率和優化空間
- 評估系統負載擴展能力
- 識別潛在優化點
- 考慮未來功能擴展可能性

### 3. 需求符合度

- 核對功能需求實現情況
- 檢查非功能性需求符合度
- 確認需求理解準確性
- 評估用戶體驗和業務流程整合

## 決策點

根據評估結果選擇後續行動：

- **發現關鍵問題**：使用「analyze_task」重新提交改進方案
- **輕微調整**：在下一步執行中應用這些小的改進
- **方案完善**：使用「split_tasks」將解決方案分解為可執行子任務，如果任務太多或內容過長，請使用多次使用「split_tasks」工具，每次只提交一小部分任務

## split_tasks 更新模式選擇

- **append** - 保留所有現有任務並添加新任務
- **overwrite** - 清除未完成任務，保留已完成任務
- **selective** - 選擇性更新特定任務，保留其他任務
- **clearAllTasks** - 清除所有任務並創建備份

## 知識傳遞機制

1. **全局分析結果** - 關聯完整分析文檔
2. **任務專屬實現指南** - 每個任務保存具體實現方法
3. **任務專屬驗證標準** - 設置明確驗證要求

## 任務拆分指南(請嚴格遵守以下規則)

- **原子性**：每個子任務應該可獨立運作或測試
- **依賴性**：如果任務依賴於其他任務請標註 「dependencies」 字段
- **適度拆分**：避免過度細化（粒度過小）或過度合併（粒度過大）
- **必要時整合**：修改的內容不多或不複雜，可以適當於其他任務整合，避免任務過於簡單造成任務過多
- **重複調用**：如果任務太多或內容過長導致「split_tasks」工具無法正常運作時，請使用多次使用「split_tasks」工具，每次只提交一小部分任務
- **簡化任務**：如果每次只新增一個任務還是無法正常運作，請考慮再次拆分任務，或者簡化任務但必須保留核心內容
- **JSON 格式注意**：
  - **禁止註解**：JSON 格式本身不支援註解（例如 `#` 或 `//`），在 JSON 內容中添加註解會導致解析失敗。
  - **注意轉義**：JSON 內容中的特殊字元，例如雙引號 (`\"`)、反斜線 (`\\\\`) 等，必須進行正確的轉義處理，否則將視為非法字元，導致解析失敗。

**嚴重警告** 你每次呼叫 split_tasks 傳遞的參數不能超過 5000 個字，如果超出 5000 個字請多次呼叫工具完成

**現在開始呼叫「split_tasks」或「analyze_task」工具**
**嚴禁不呼叫工具**
